

clear all;
close all;
format long;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



write=fopen('1D99681e3_CFL1p0_tau1p9_T1000_wn1_N81_RSSPK.txt','w');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tinit=cputime;
N=161;
dx =1/(N-1);
CFL=0.85;
dt=CFL*(dx);
T=1000;
%M=int32(T/dt);
M=ceil(T/dt);
a=1;            % Ut=aUx  
wave_num=1*2*pi;
tau=2;                    % penalty     1 < tau < 2.4

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Coefficients for SSP-RK
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

kt=7;
    alpha=coefb(kt);
    cbin=coefbin(kt);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

xj=zeros(N,1);

for j=1:N
    xj(j,1)=dx*(j-1);
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Uj=zeros(size(xj));      % numerical solution 
g=zeros(size(xj));       % S_0 

Uj_ex=zeros(size(xj));   % exact sollution
esp=zeros(size(xj));     % error vector over space





D=zeros(N,N);
P=zeros(N,N);
Q=zeros(N,N);

[P,Q,IP,D]=Diff_CompFD99681_e3(N);





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


g(1,1)=a*tau*Q(1,1);

Qp=Q;
%Qp(1,1)=Qp(1,1)*(1-tau);








%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Uj=sin(wave_num*xj);           % initial data 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% RK-4

temp1=zeros(size(xj));   % RKɶ{Ǥxs
temp2=zeros(size(xj));   % RKɶ{Ǥxs

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% figure(1)
% 
% wave_Uj = plot(xj(1:N),Uj(1:N),'-o','Markersize',8,...
%     'EraseMode','Xor');
% axis([0 1 -1.5 1.5]);
% xlabel('x');
% ylabel('U');
% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% pause;


L=0;
% EL2T=zeros(M,1)
% ESUT=zeros(M,1)
% tj=zeros(M,1)

for k=1:M
L=L+1;

%     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     temp1=Uj;
%     
%     temp2=IP*(-a*Qp*temp1-g*(sin(-wave_num*(L-1)*dt)));
%     
%     Uj=Uj+(1/6)*dt*temp2;
%     
%     %(sin(-(L-1)*dt)-(dt/2)*cos((L-1)*dt))
%     %(sin(-(L-1/2)*dt))
%     temp2=IP*(-a*Qp*(temp1+(1/2)*dt*temp2)-g*(sin(-wave_num*(L-1)*dt)-...
%         (dt/2)*wave_num*cos(wave_num*(L-1)*dt)));
%     
%     Uj=Uj+(2/6)*dt*temp2;
%     
%     % (sin(-(L-1)*dt)-(dt/2)*cos((L-1)*dt)+(dt^2/4)*sin((L-1)*dt))
%     % (sin(-(L-1/2)*dt))
%     temp2=IP*(-a*Qp*(temp1+(1/2)*dt*temp2)-g*(sin(-wave_num*(L-1)*dt)-...
%         (dt/2)*wave_num*cos(wave_num*(L-1)*dt)+(dt^2/4)*(wave_num^2)*sin(wave_num*(L-1)*dt)));
%     
%     Uj=Uj+(2/6)*dt*temp2;
%     
%     % (sin(-(L-1)*dt)-dt*cos((L-1)*dt)+(dt^2/2)*sin((L-1)*dt)+(dt^3/4)*cos((L-1)*dt))
%     % (sin(-(L)*dt))
%     temp2=IP*(-a*Qp*(temp1+dt*temp2)-g*(sin(-wave_num*(L-1)*dt)-dt*wave_num*cos(wave_num*(L-1)*dt)+...
%         (dt^2/2)*(wave_num^2)*sin(wave_num*(L-1)*dt)+(dt^3/4)*(wave_num^3)*cos(wave_num*(L-1)*dt)));
%     
%     Uj=Uj+(1/6)*dt*temp2;
%     
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %     
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        t_loc=wave_num*(L-1)*dt;    
        dw=dt*wave_num;
        df(1)=sin(-t_loc);
        df(2)=-dw*cos(-t_loc);
        df(3)=-dw^2*sin(-t_loc);
        df(4)=dw^3*cos(-t_loc);
        df(5)=dw^4*sin(-t_loc);
        df(6)=-dw^5*cos(-t_loc);
        df(7)=-dw^6*sin(-t_loc);
        
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        temp1=Uj;
        temp3=alpha(1)*Uj;
            
        for i=1:kt-2
        temp1=Uj;
        temp=0;
        for j=1:i
            temp=temp+cbin(i,j)*df(j);
        end
      %  temp=dot(cbin(i,1:i),df(1:i));
            temp2=IP*(-a*Qp*temp1+g*(temp1(1,1)-temp));
        Uj=Uj+dt*temp2;
        temp3=temp3+alpha(i+1)*Uj;
        end
        
        temp1=Uj;
        temp=0;
        for j=1:kt-1
            temp=temp+cbin(kt-1,j)*df(j);
        end
        
        temp2=IP*(-a*Qp*temp1+g*(temp1(1,1)-temp));
        Uj=Uj+dt*temp2;
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                
        temp1=Uj;
        temp=0;
        for j=1:kt
            temp=temp+cbin(kt,j)*df(j);
        end
            temp2=IP*(-a*Qp*temp1+g*(temp1(1,1)-temp));
        Uj=Uj+dt*temp2;
        
        temp3=temp3+alpha(kt)*Uj;
        Uj=temp3;
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    

    
    
% set(wave_Uj,'YDATA',Uj(1:N));
% drawnow;


for j=1:N
    Uj_ex(j,1)=sin(wave_num*((j-1)*dx-a*L*dt));
end




err=abs(Uj-Uj_ex);
errL2=sqrt((err')*err*dx);
errsup=max(err);
% tj(L,1)=L*dt

%fprintf('%d    %d    %d\n',L*dt,errL2,errsup);
fprintf(write,'%d    %d    %d\n',L*dt,errL2,errsup);


% EL2T(L,1)=errL2
% ESUT(L,1)=errsup


end;


fclose(write);

% figure(2)
% 
% wave_Uj = plot(tj,EL2T,'-*','Markersize',8,...
%     'EraseMode','Xor');
% axis([0 T -1.5 1.5]);
% xlabel('t');
% ylabel('L^2-norm');
% 
% 
% 
% figure(3)
% 
% wave_Uj = plot(tj,ESUT,'-*','Markersize',8,...
%     'EraseMode','Xor');
% axis([0 T -1.5 1.5]);
% xlabel('t');
% ylabel('Sup-norm');
% 
% 
% time_final=L*dt;
% 
% for j=1:N
%     Uj_ex(j,1)=sin(wave_num*((j-1)*dx-a*time_final));
% end
% 
% 
% err=abs(Uj-Uj_ex);
% errL2P=((err')*P*err*dx)^0.5
% errL2=((err')*err*dx)^0.5
% errsup=max(err)
% 
tend=cputime;
tend-tinit