clear all;
close all;
format long;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% write=fopen('1Dsystem99681e3_CFL0p8_tau1p1_T1_N21_RSSPK.txt','w');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tinit=cputime;
N=41;
dx =1/(N-1);
CFL=0.8;
dt=CFL*(dx);
T=10;
%M=int32(T/dt);
M=ceil(T/dt);
% a=1;            % Ut=-aUx  
wave_num=2*pi;
tau_0=1.1;                    % penalty     1 < tau < 2.4
tau_N=1.1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Coefficients for SSP-RK
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

kt=7;
    alpha=coefb(kt);
    cbin=coefbin(kt);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

xj=zeros(N,1);

for j=1:N
    xj(j,1)=dx*(j-1);
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Uj=zeros(size(xj));      % numerical solution 
Vj=zeros(size(xj));
Uj_ex=zeros(size(xj));
Vj_ex=zeros(size(xj));

V=zeros(2*length(xj),1);
V_ex=zeros(size(V));
g=zeros(2*length(xj),1);       % S_0 

Uj_ex=zeros(size(xj));   % exact sollution
esp=zeros(size(xj));     % error vector over space

A=[0 1;1 0];
I2=eye(2);
A_p=zeros(2,2);
A_n=zeros(2,2);
[A_p,A_n]=upwind(A);

D=zeros(N,N);
P=zeros(N,N);
Q=zeros(N,N);

[P,Q,IP_0,D]=Diff_CompFD99681_e3(N);
% [P,Q,IP_0,D]=Diff_CompFD77451_e1(N);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

temp_Ap=zeros(N,N);
temp_An=zeros(N,N);

temp_Ap(1,1)=1;
temp_An(N,N)=1;
A_upwind=kron(temp_Ap,tau_0*Q(1,1)*A_p)+kron(temp_An,tau_N*Q(N,N)*A_n);


Qp=Q;
%Qp(1,1)=Qp(1,1)*(1-tau);

IP=kron(IP_0,I2);
Qp=kron(Q,-A);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Uj=sin(wave_num*xj);           % initial data 
Vj=sin(wave_num*xj);
Uj_ex=sin(wave_num*xj);
Vj_ex=sin(wave_num*xj);
% for i=1:N
% %     Uj(i)=xj(i)^4;
%     if xj(i)<=1/2 
%         Uj(i)=1/2*2^24*((xj(i)-1/2)^6)*(xj(i)^6);
%         Vj(i)=1/2*2^24*((xj(i)-1/2)^6)*(xj(i)^6);
%         
%     end
% end
    
for i=1:N
    V(2*i-1,1)=Uj(i,1);
    V(2*i,1)=Vj(i,1);
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% RK-4

temp1=zeros(size(V));   % RKɶ{Ǥxs
temp2=zeros(size(V));   % RKɶ{Ǥxs

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% figure(1)
% wave_Uj = plot(xj(1:N),Uj(1:N),'-bo','Markersize',8,...
%     'EraseMode','Xor');
% axis([0 1 -1.5 1.5]);
% % xlabel('x');
% % ylabel('U');
% 
% % hold on
% % 
% figure(2)
% wave_Vj = plot(xj(1:N),Vj(1:N),'-rs','Markersize',8,...
%     'EraseMode','Xor');
% axis([0 1 -1.5 1.5]);
% % xlabel('x');
% % ylabel('V');
% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% pause;


L=0;
% EL2T=zeros(M,1)
% ESUT=zeros(M,1)
% tj=zeros(M,1)

for k=1:M
L=L+1;

        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        t_loc1=-wave_num*(L-1)*dt;    
        dw1=-dt*wave_num;
        df1_1(1)=sin(t_loc1);
        df1_1(2)=dw1*cos(t_loc1);
        df1_1(3)=-dw1^2*sin(t_loc1);
        df1_1(4)=-dw1^3*cos(t_loc1);
        df1_1(5)=dw1^4*sin(t_loc1);
        df1_1(6)=dw1^5*cos(t_loc1);
        df1_1(7)=-dw1^6*sin(t_loc1);
        
        df1_2(1)=sin(t_loc1);
        df1_2(2)=dw1*cos(t_loc1);
        df1_2(3)=-dw1^2*sin(t_loc1);
        df1_2(4)=-dw1^3*cos(t_loc1);
        df1_2(5)=dw1^4*sin(t_loc1);
        df1_2(6)=dw1^5*cos(t_loc1);
        df1_2(7)=-dw1^6*sin(t_loc1);
        
        t_loc2=wave_num*(1-(L-1)*dt);    
        dw2=-dt*wave_num;
        df2_1(1)=sin(t_loc2);
        df2_1(2)=dw2*cos(t_loc2);
        df2_1(3)=-dw2^2*sin(t_loc2);
        df2_1(4)=-dw2^3*cos(t_loc2);
        df2_1(5)=dw2^4*sin(t_loc2);
        df2_1(6)=dw2^5*cos(t_loc2);
        df2_1(7)=-dw2^6*sin(t_loc2);
            
        df2_2(1)=sin(t_loc2);
        df2_2(2)=dw2*cos(t_loc2);
        df2_2(3)=-dw2^2*sin(t_loc2);
        df2_2(4)=-dw2^3*cos(t_loc2);
        df2_2(5)=dw2^4*sin(t_loc2);
        df2_2(6)=dw2^5*cos(t_loc2);
        df2_2(7)=-dw2^6*sin(t_loc2);



%         df1_1(1:7)=0;
%         df1_2(1:7)=0;
%         df2_1(1:7)=0; 
%         df2_2(1:7)=0;

        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        temp1=V;
        temp3=alpha(1)*V;
            
        for i=1:kt-2
            temp1=V;
            temp=zeros(2,2);
            for j=1:i
            
                temp(1,1)=temp(1,1)+cbin(i,j)*df1_1(j);
                temp(1,2)=temp(1,2)+cbin(i,j)*df1_2(j);
                temp(2,1)=temp(2,1)+cbin(i,j)*df2_1(j);
                temp(2,2)=temp(2,2)+cbin(i,j)*df2_2(j);
            end
            %  temp=dot(cbin(i,1:i),df(1:i));
            g(1,1)=temp1(1,1)-temp(1,1);
            g(2,1)=temp1(2,1)-temp(1,2);
            g(2*N-1,1)=temp1(2*N-1,1)-temp(2,1);
            g(2*N,1)=temp1(2*N,1)-temp(2,2);
            
            temp2=IP*(Qp*temp1+A_upwind*g);
            V=V+dt*temp2;
            temp3=temp3+alpha(i+1)*V;
        end

        
        temp1=V;
        temp=zeros(2,2);
        for j=1:kt-1
            temp(1,1)=temp(1,1)+cbin(kt-1,j)*df1_1(j);
            temp(1,2)=temp(1,2)+cbin(kt-1,j)*df1_2(j);
            temp(2,1)=temp(2,1)+cbin(kt-1,j)*df2_1(j);
            temp(2,2)=temp(2,2)+cbin(kt-1,j)*df2_2(j);
        end


        g(1,1)=temp1(1,1)-temp(1,1);
        g(2,1)=temp1(2,1)-temp(1,2);
        g(2*N-1,1)=temp1(2*N-1,1)-temp(2,1);
        g(2*N,1)=temp1(2*N,1)-temp(2,2);
        
        
        temp2=IP*(Qp*temp1+A_upwind*g);
        V=V+dt*temp2;
                
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                
        temp1=V;
        temp=zeros(2,2);
        for j=1:kt
            temp(1,1)=temp(1,1)+cbin(kt,j)*df1_1(j);
            temp(1,2)=temp(1,2)+cbin(kt,j)*df1_2(j);
            temp(2,1)=temp(2,1)+cbin(kt,j)*df2_1(j);
            temp(2,2)=temp(2,2)+cbin(kt,j)*df2_2(j);
        end    
        g(1,1)=temp1(1,1)-temp(1,1);
        g(2,1)=temp1(2,1)-temp(1,2);
        g(2*N-1,1)=temp1(2*N-1,1)-temp(2,1);
        g(2*N,1)=temp1(2*N,1)-temp(2,2);
        
        temp2=IP*(Qp*temp1+A_upwind*g);
        V=V+dt*temp2;
        
        temp3=temp3+alpha(kt)*V;
        V=temp3;
        
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
        for i=1:N
            Uj(i,1)=V(2*i-1,1);
            Vj(i,1)=V(2*i,1);
        end
    
    
%         set(wave_Uj,'YDATA',Uj(1:N));
%         set(wave_Vj,'YDATA',Vj(1:N));
        drawnow;


        for j=1:N
            Uj_ex(j,1)=sin(wave_num*((j-1)*dx-L*dt));
            Vj_ex(j,1)=sin(wave_num*((j-1)*dx-L*dt));
            V_ex(2*j-1,1)=Uj_ex(j,1);
            V_ex(2*j,1)=Vj_ex(j,1);
        end

        err_Uj=abs(Uj-Uj_ex);
        errL2_Uj=sqrt((err_Uj')*err_Uj*dx);
        errsup_Uj=max(err_Uj);
        
        err_Vj=abs(Vj-Vj_ex);
        errL2_Vj=sqrt((err_Vj')*err_Vj*dx);
        errsup_Vj=max(err_Vj);
        
%         err_V=abs(V-V_ex);
%         errL2_V=sqrt((err_V')*err_V*dx);
%         errsup_V=max(err_V);
% tj(L,1)=L*dt

% fprintf(write,'%d    %d    %d\n',L*dt,errL2_V,errsup_V);

end;
% 
% fclose(write);
% 
tend=cputime;
tend-tinit