clear all;
close all;
format long;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% write=fopen('1Dsystem99681e3_CFL0p8_tau1p1_T1_N21_RSSPK.txt','w');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tinit=cputime;
N=41;
dx =1/(N-1);
CFL=0.8;
dt=CFL*(dx);
T=10;
%M=int32(T/dt);
M=ceil(T/dt);
% a=1;            % Ut=-aUx  
wave_num=2*pi;
tau_0=1.1;                    % penalty     1 < tau < 2.4
tau_L=1.1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Coefficients for SSP-RK
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

kt=7;
    alpha=coefb(kt);
    cbin=coefbin(kt);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

xj=zeros(N,1);

for j=1:N
    xj(j,1)=dx*(j-1);
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Uj=zeros(size(xj));      % numerical solution 
Vj=zeros(size(xj));
Uj_ex=zeros(size(xj));
Vj_ex=zeros(size(xj));

V=zeros(2*length(xj),1);
V_ex=zeros(size(V));
g1=zeros(size(xj));       % S_0 
g2=zeros(size(xj));

Uj_ex=zeros(size(xj));   % exact sollution
esp=zeros(size(xj));     % error vector over space

A=[0 1;1 0];
I2=eye(2,2);
A_p=zeros(2,2);
A_n=zeros(2,2);
[A_p,A_n]=upwind(A);

D=zeros(N,N);
P=zeros(N,N);
Q=zeros(N,N);

[P,Q,IP,D]=Diff_CompFD99681_e3(N);
% [P,Q,IP_0,D]=Diff_CompFD77451_e1(N);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


Qp=Q;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Uj=sin(wave_num*xj);           % initial data 
Vj=sin(wave_num*xj);
Uj_ex=sin(wave_num*xj);
Vj_ex=sin(wave_num*xj);
% for i=1:N
% %     Uj(i)=xj(i)^4;
%     if xj(i)<=1/2 
%         Uj(i)=1/2*2^24*((xj(i)-1/2)^6)*(xj(i)^6);
%         Vj(i)=1/2*2^24*((xj(i)-1/2)^6)*(xj(i)^6);
%         
%     end
% end
    


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% RK

temp1_u=zeros(size(Uj));   % RKɶ{Ǥxs
temp1_v=zeros(size(Vj));

temp2_u=zeros(size(Uj));   % RKɶ{Ǥxs
temp2_v=zeros(size(Vj));

tau_g1=zeros(size(g1));
tau_g2=zeros(size(g2));
temp_tau=zeros(2,1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% figure(1)
% wave_Uj = plot(xj(1:N),Uj(1:N),'-bo','Markersize',8,...
%     'EraseMode','Xor');
% axis([0 1 -1.5 1.5]);
% % xlabel('x');
% % ylabel('U');
% 
% % hold on
% % 
% figure(2)
% wave_Vj = plot(xj(1:N),Vj(1:N),'-rs','Markersize',8,...
%     'EraseMode','Xor');
% axis([0 1 -1.5 1.5]);
% xlabel('x');
% ylabel('V');
% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % 
% pause;





L=0;
% EL2T=zeros(M,1)
% ESUT=zeros(M,1)
% tj=zeros(M,1)

for k=1:M
L=L+1;

        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        t_loc1=-wave_num*(L-1)*dt;    
        dw1=-dt*wave_num;
        df1_u(1)=sin(t_loc1);
        df1_u(2)=dw1*cos(t_loc1);
        df1_u(3)=-dw1^2*sin(t_loc1);
        df1_u(4)=-dw1^3*cos(t_loc1);
        df1_u(5)=dw1^4*sin(t_loc1);
        df1_u(6)=dw1^5*cos(t_loc1);
        df1_u(7)=-dw1^6*sin(t_loc1);
        
        df1_v(1)=sin(t_loc1);
        df1_v(2)=dw1*cos(t_loc1);
        df1_v(3)=-dw1^2*sin(t_loc1);
        df1_v(4)=-dw1^3*cos(t_loc1);
        df1_v(5)=dw1^4*sin(t_loc1);
        df1_v(6)=dw1^5*cos(t_loc1);
        df1_v(7)=-dw1^6*sin(t_loc1);
        
        t_loc2=wave_num*(1-(L-1)*dt);    
        dw2=-dt*wave_num;
        df2_u(1)=sin(t_loc2);
        df2_u(2)=dw2*cos(t_loc2);
        df2_u(3)=-dw2^2*sin(t_loc2);
        df2_u(4)=-dw2^3*cos(t_loc2);
        df2_u(5)=dw2^4*sin(t_loc2);
        df2_u(6)=dw2^5*cos(t_loc2);
        df2_u(7)=-dw2^6*sin(t_loc2);
            
        df2_v(1)=sin(t_loc2);
        df2_v(2)=dw2*cos(t_loc2);
        df2_v(3)=-dw2^2*sin(t_loc2);
        df2_v(4)=-dw2^3*cos(t_loc2);
        df2_v(5)=dw2^4*sin(t_loc2);
        df2_v(6)=dw2^5*cos(t_loc2);
        df2_v(7)=-dw2^6*sin(t_loc2);


%         df1_u(1:7)=0;
%         df1_v(1:7)=0;
%         df2_u(1:7)=0; 
%         df2_v(1:7)=0;

        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        temp1_u=Uj;
        temp1_v=Vj;
        temp3_u=alpha(1)*Uj;
        temp3_v=alpha(1)*Vj;
            
        for i=1:kt-2
            temp1_u=Uj;
            temp1_v=Vj;
            temp=zeros(2,2);
            for j=1:i
            
                temp(1,1)=temp(1,1)+cbin(i,j)*df1_u(j);
                temp(1,2)=temp(1,2)+cbin(i,j)*df1_v(j);
                temp(2,1)=temp(2,1)+cbin(i,j)*df2_u(j);
                temp(2,2)=temp(2,2)+cbin(i,j)*df2_v(j);
            end
%             g1=zeros(size(temp1_u));
%             g2=zeros(size(temp1_v));
            g1(1)=temp1_u(1,1)-temp(1,1);
            g2(1)=temp1_v(1,1)-temp(1,2);
            g1(N)=temp1_u(N,1)-temp(2,1);
            g2(N)=temp1_v(N,1)-temp(2,2);
            
                                    
            temp_tau=multiply_tau(g1,g2,1,A_p);
            tau_g1(1)=tau_0*Q(1,1)*temp_tau(1);
            tau_g2(1)=tau_0*Q(1,1)*temp_tau(2);
            temp_tau=multiply_tau(g1,g2,N,A_n);
            tau_g1(N)=tau_L*Q(N,N)*temp_tau(1);
            tau_g2(N)=tau_L*Q(N,N)*temp_tau(2);
            
                        
            [temp1_u,temp1_v]=multiply_UV(temp1_u,temp1_v,-A);
            
            temp2_u=IP*(Qp*temp1_u+tau_g1);
            temp2_v=IP*(Qp*temp1_v+tau_g2);
                        
            Uj=Uj+dt*temp2_u;
            Vj=Vj+dt*temp2_v;          
            temp3_u=temp3_u+alpha(i+1)*Uj;
            temp3_v=temp3_v+alpha(i+1)*Vj;
            
        end
        
       
        temp1_u=Uj;
        temp1_v=Vj;
        temp=zeros(2,2);
        for j=1:kt-1
            temp(1,1)=temp(1,1)+cbin(kt-1,j)*df1_u(j);
            temp(1,2)=temp(1,2)+cbin(kt-1,j)*df1_v(j);
            temp(2,1)=temp(2,1)+cbin(kt-1,j)*df2_u(j);
            temp(2,2)=temp(2,2)+cbin(kt-1,j)*df2_v(j);
        end


        g1(1)=temp1_u(1,1)-temp(1,1);
        g2(1)=temp1_v(1,1)-temp(1,2);
        g1(N)=temp1_u(N,1)-temp(2,1);
        g2(N)=temp1_v(N,1)-temp(2,2);
                      
        temp_tau=multiply_tau(g1,g2,1,A_p);
        tau_g1(1)=tau_0*Q(1,1)*temp_tau(1);
        tau_g2(1)=tau_0*Q(1,1)*temp_tau(2);
        temp_tau=multiply_tau(g1,g2,N,A_n);
        tau_g1(N)=tau_L*Q(N,N)*temp_tau(1);
        tau_g2(N)=tau_L*Q(N,N)*temp_tau(2);
        
        [temp1_u,temp1_v]=multiply_UV(temp1_u,temp1_v,-A);           
           
        temp2_u=IP*(Qp*temp1_u+tau_g1);
        temp2_v=IP*(Qp*temp1_v+tau_g2);
                
        Uj=Uj+dt*temp2_u;
        Vj=Vj+dt*temp2_v;
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                
        temp1_u=Uj;
        temp1_v=Vj;
        temp=zeros(2,2);
        for j=1:kt
            temp(1,1)=temp(1,1)+cbin(kt,j)*df1_u(j);
            temp(1,2)=temp(1,2)+cbin(kt,j)*df1_v(j);
            temp(2,1)=temp(2,1)+cbin(kt,j)*df2_u(j);
            temp(2,2)=temp(2,2)+cbin(kt,j)*df2_v(j);
        end    

        g1(1)=temp1_u(1,1)-temp(1,1);
        g2(1)=temp1_v(1,1)-temp(1,2);
        g1(N)=temp1_u(N,1)-temp(2,1);
        g2(N)=temp1_v(N,1)-temp(2,2);
                      
        temp_tau=multiply_tau(g1,g2,1,A_p);
        tau_g1(1)=tau_0*Q(1,1)*temp_tau(1);
        tau_g2(1)=tau_0*Q(1,1)*temp_tau(2);
        temp_tau=multiply_tau(g1,g2,N,A_n);
        tau_g1(N)=tau_L*Q(N,N)*temp_tau(1);
        tau_g2(N)=tau_L*Q(N,N)*temp_tau(2);
        
        [temp1_u,temp1_v]=multiply_UV(temp1_u,temp1_v,-A);           
           
        temp2_u=IP*(Qp*temp1_u+tau_g1);
        temp2_v=IP*(Qp*temp1_v+tau_g2);
                
        Uj=Uj+dt*temp2_u;
        Vj=Vj+dt*temp2_v;
        
        temp3_u=temp3_u+alpha(kt)*Uj;
        temp3_v=temp3_v+alpha(kt)*Vj;
        
        Uj=temp3_u;
        Vj=temp3_v;
        
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    
    
%         set(wave_Uj,'YDATA',Uj(1:N));
%         set(wave_Vj,'YDATA',Vj(1:N));
        drawnow;


        for j=1:N
            Uj_ex(j,1)=sin(wave_num*((j-1)*dx-L*dt));
            Vj_ex(j,1)=sin(wave_num*((j-1)*dx-L*dt));
            V_ex(2*j-1,1)=Uj_ex(j,1);
            V_ex(2*j,1)=Vj_ex(j,1);
        end

        err_Uj=abs(Uj-Uj_ex);
        errL2_Uj=sqrt((err_Uj')*err_Uj*dx);
        errsup_Uj=max(err_Uj);
        
        err_Vj=abs(Vj-Vj_ex);
        errL2_Vj=sqrt((err_Vj')*err_Vj*dx);
        errsup_Vj=max(err_Vj);

        
% tj(L,1)=L*dt

% fprintf(write,'%d    %d    %d\n',L*dt,errL2_V,errsup_V);


% EL2T(L,1)=errL2
% ESUT(L,1)=errsup

end;
% 
% fclose(write);
% 
tend=cputime;
tend-tinit